#!/bin/sh
arch=arm-linux
cc=$arch-gcc
cpp=$arch-g++
ranlib=$arch-ranlib
builddir=`pwd`
topdir=${builddir}/..
qtdir=${topdir}/opt/Qtopia
export QTDIR=$qtdir
archive=vm.ar
plugin_archive=plugins/plugins.ar
includes="-I${builddir} -I${qtdir}/include -I${qtdir}/sharp/include"
libdir="-L${qtdir}/sharp/lib -L./morelibs"
flags="-O2 -DNON_ZAURUS_ENVIRONMENT -DHEADLESS -DLSB_FIRST=1 -DHAVE_TIMEZONE -DVM_HOST_OS=\"linux\" -DVM_HOST_CPU=\"arm\" -DVM_VERSION=3.14 -DVM_LIBDIR=\"./\" -D_OS_UNIX_ -DQWS"
cppflags="-fno-rtti"
libs="-lqte -lqpe -lpthread"

doit(){
	echo $*
	nice $*
	if [ $? != 0 ] ;then exit;fi
}

if [ ! -f $plugin_archive ] ; then
	cd plugins/
	./make.sh
	cd $builddir
fi

rm $archive

doit ./verstamp version.c $cc

ccparts="sqQPEGlue interp aio osExports sqVirtualMachine sqUnixExternalPrims sqNamedPrims version"
cppparts="sqQPEWindow moc_sqQPEWindow"
mocparts="sqQPEWindow" 

for foo in $mocparts;do
	doit $qtdir/bin/moc $foo.h -o moc_$foo.c
done

for foo in $ccparts;do
	doit $cc -c $includes $flags $foo.c -o $foo.o
	doit ar -r $archive $foo.o
	rm $foo.o
done

for foo in $cppparts;do
	doit $cpp -c $includes $flags $cppflags $foo.c* -o $foo.o
	doit ar -r $archive $foo.o
	rm $foo.o
done

doit $ranlib $archive
doit $cpp $libdir $archive $plugin_archive $libs -o squeak
