#include <qapplication.h>
#include <qpe/qpeapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qpe/applnk.h>
#include <qpe/fileselector.h>
//#include <sl/slfileselector.h>
#include <qmainwindow.h>
#include <qnamespace.h>
#include <qpainter.h>
#include <pthread.h>

class SqueakWindow : public QMainWindow {
  Q_OBJECT

public:
  SqueakWindow(QWidget* parent=0, const char* name=0, WFlags f=0);
  virtual ~SqueakWindow();

protected:
  virtual void mousePressEvent(QMouseEvent *e);
  virtual void mouseReleaseEvent(QMouseEvent *e);
  virtual void mouseMoveEvent(QMouseEvent *e);
  virtual void mouseDoubleClickEvent(QMouseEvent *e);
  virtual void keyPressEvent(QKeyEvent*);
  virtual void keyReleaseEvent(QKeyEvent *e);
  virtual void resizeEvent(QResizeEvent * e);
  virtual void closeEvent(QCloseEvent *ce);
  virtual void focusInEvent(QFocusEvent *evt);
  /* virtual void showEvent(QShowEvent *e); */
  /* virtual void paintEvent(QPaintEvent * e); */
  
  /* virtual bool SqueakWindow::event(QEvent *e); */
#ifdef USE_SL_FILESELECTOR
  SlFileSelector *fileSelector;
#else
  FileSelector *fileSelector;
#endif

  void enableFullScreen();
  void disableFullScreen();

public:
  QWidget* SqueakWindow::openFileDialog();
  void SetUpWindow();
  void SetupQPEDisplay();
  void run();

public slots:
  //void setShortImageName(const QFileInfo& fileInfo);
 void setShortImageName(const DocLnk& doc);
  void closeFileSelector();
};
